/**
 * Copyright © 2013 by Data Virtuality GmbH
 */
package com.datavirtuality.dv.core.interfaces;


/**
 * Teiid extension to handle custom system tables and stored procedures
 * 
 * @author Roman Pedchenko
 * @date 10.08.2012
 */
public interface TeiidExtension0 {
	/**
	 * Custom system tables handler.
	 * 
	 * @param command original query
	 * @return a {@link TupleSource} instance if the extension processed the command, null otherwise
	 * @throws Exception if an error occurs running this extension
	 */
	public Object run1(Object command, Object commandContext) throws Exception;

	/**
	 * Custom system procedures handler.
	 * 
	 * @param command original command
	 * @return a {@link TupleSource} instance if the extension processed the command, null otherwise
	 * @throws Exception if an error occurs running this extension
	 */
	public Object run2(Object command, Object commandContext) throws Exception;
}
